rollout scribeRoll "by Nikolay Ragozin" (
	local SelObj=undefined

	label doc1 "Left Button for Pick Selected Object" offset:[0,10]
	label doc2 "Right Button for Interative Update"
	button CenterBut "Center" across:3
	button AxisBut "Axis 0XY"
	button ResetBut "Reset"
	label objectL
	timer t1 interval:10

	fn transformByScribe=(
		vc=scrVector()
		aavc=[sin(acos(vc.x)),sin(acos(vc.y)),sin(acos(vc.z))]
		ps=scrCoord()
		a=matrix3 [-vc.y/aavc.z,vc.x/aavc.z,0] [-vc.z*vc.x/aavc.z,-vc.z*vc.y/aavc.z,aavc.z] [vc.x,vc.y,vc.z] ps
		try (
			flagForeground selObj on
			SelObj.transform=a
			flagForeground selObj off
		) catch()
	)
	
	on scribeRoll open do (
		scrConnect 1 3
		t1.active=on
	)
	
	on scribeRoll close do (
		scrDisconnect()
		t1.active=off
	)

	on t1 tick do (
		t1.active=off
		if (scrUpdate on)==undefined do (t1.active=on;return())
		if ((scrButtons()).x==1) do (
			SelObj=selection[1]
			objectL.text=try(SelObj.name) catch("")
		)
		if ((scrButtons()).y==1) do (transformByScribe())
		t1.active=on
	)

	on CenterBut Pressed do (
		t1.active=off
		unRegisterRedrawViewsCallback transformByScribe
		objectL.text="Pick Center by Right Button"
		while ((scrButtons off).y==0) do ()
		scrSetTranslate (-(scrCoord ()))
		while ((scrButtons off).y==1) do ()
		objectL.text=try(SelObj.name) catch("")
		t1.active=on
	)

	on AxisBut Pressed do (
		t1.active=off
		objectL.text="Pick Center by Right Button"

		local OO=[0,0,0],XX=[0,0,0],YY=[0,0,0]
		while ((scrButtons off).y==0) do ()
		OO=scrCoord off
		while ((scrButtons off).y==1) do ()
		objectL.text="Pick X offset"

		while ((scrButtons off).y==0) do ()
		XX=scrCoord off
		while ((scrButtons off).y==1) do ()
		objectL.text="Pick Y plane offset"

		while ((scrButtons off).y==0) do ()
		YY=scrCoord off
		while ((scrButtons off).y==1) do ()

		MX=OO-XX
		MY=YY-OO
		MZ=(cross MX MY)
		scrSetQRotate (inverse ((matrix3 (normalize MX) (normalize(cross MX MZ)) (normalize MZ) [0,0,0]).rotationpart))

		objectL.text=try(SelObj.name) catch("")
		t1.active=on
	)
	on ResetBut pressed do (
		scrReset()
	)
)

addrollout scribeRoll (NewRolloutFloater "MicroScribe Test Interface" 230 200)
